# heise.tcl v1.4 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl  liest  die www.heise.de  news aus  und gibt  sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.4 - komplett umgebaut by public request
#
# heisetrigger - der trigger auf den der bot reagiert (public und message)
# heiselimit - maximum der news die auf befehl geposted werden
# heisenewspost  - 1 fr newsposting, 0 fr keines
# heisechans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# heisenewspostlimit - maximum der news die geposted werden
# isheisehub  - legt fest ob der bot newshub ist oder nicht
# heiseleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set heisetrigger ".heise"
set heisechans ""
set heiselimit "10"
set heisenewspostlimit "3"
set heisenewspost "1"
set isheisehub "0"
set heiseleafs ""

####### ende der config #############

bind msg - $heisetrigger msg_heise
bind pub - $heisetrigger pub_heise
bind time - "?0 * * * *" heisecheck

proc sendheisenews { arg } {
global heiseleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $heiseleafs] [string tolower $bot]] != -1)} {
putbot $bot "heise: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
return $text
}

proc heisecheck {nick uhost hand chan arg} {
global heisechans heisenewspost isheisehub heisenewspostlimit
set counter 0
if {$heisenewspost == 1 } {
putlog "heise: suche nach neuer newsline"
set heiselastnews "none"
if {[file exists heise.hdl]} {
set temp [open "heise.hdl" r]
set heiselastnews "[gets $temp]"
close $temp
}
set temp [open "heise.hdl" w+]
if {[catch {set sock [socket www.heise.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.heise.de"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "/newsticker/data/" $bl] != -1} {
set link "www.heise.de/[string range $bl [shrink + 11 "a href=\"/" 0 $bl] [shrink - 1 "\">" 0 $bl]]"
set newsline [string range $bl [shrink + 3 "/\">" 0 $bl] [shrink - 1 "</A>" 0 $bl]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$heiselastnews == "none" } { putlog "heise: headlinefile created" ; return 0 }
set temp [open "heise.hdl" r]
while { [eof $temp] != 1 } {
set heiseneunews [gets $temp]
if {($heiselastnews == $heiseneunews) || ($counter == $heisenewspostlimit)} { close $temp;return 0 }
if {$isheisehub == "1"} { sendheisenews $heiseneunews }
incr counter
foreach chan [channels] {
if {$heisechans == "" } { putserv "privmsg $chan :(neue heise newsline) $heiseneunews" }
if {$heisechans != "" } {
if {([lsearch -exact [string tolower $heisechans] [string tolower $chan]] != -1) || ($heisechans == "")} {putserv "privmsg $chan :(neue heise newsline) $heiseneunews"}
}
}}}}


proc heisenews {target limit} {
if {[catch {set sock [socket www.heise.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.heise.de"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "/newsticker/data/" $bl] != -1} {
set link "www.heise.de/[string range $bl [shrink + 11 "a href=\"/" 0 $bl] [shrink - 1 "\">" 0 $bl]]"
set newsline [string range $bl [shrink + 3 "/\">" 0 $bl] [shrink - 1 "</A>" 0 $bl]]
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_heise { nick uhost hand arg } { global heiselimit ; heisenews $nick $heiselimit }
proc pub_heise { nick uhost hand chan arg } { global heisechans heiselimit ; if {([lsearch -exact [string tolower $heisechans] [string tolower $chan]] != -1) || ($heisechans == "")} { heisenews $nick $heiselimit }}

putlog "*** heise.tcl v1.4 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]